#include <sourcemod>
#include <sdktools>

//Переменные игрока
new smoke[MAXPLAYERS+1];
new Handle:OnTimer[MAXPLAYERS+1]; 
new Float:client_pos[3];
new String:mdl[512];
//Конфиг
new Handle:sm_timertime = INVALID_HANDLE;
new Float:timertime;
new Handle:sm_smokeradius = INVALID_HANDLE;
new Float:smokeradius;
new Handle:sm_models = INVALID_HANDLE;
new String:models[512];
//Звук
#define SND_SMOKE "weapons/smokegrenade/sg_explode.wav"

public Plugin:myinfo = 
{
	name = "ZombieSmoke",
	author = "Darkeneez",
	description = "Дым вокруг зомби по нажатию клавиши.",
	version = "1.1",
	url = ""
}

public OnPluginStart()
{
 LoadTranslations("ZombieSmoke.phrases.txt");
 RegConsoleCmd("drop", drop);
 HookEvent("player_spawn", OnPlayerSpawn);
 //////////////////////////////////////////////
 //////////////////////////////////////////////
 sm_timertime = CreateConVar("sm_timertime", "30.0", "Время, через которое можно повторить выброс дыма (в секундах)");
 timertime = GetConVarFloat(sm_timertime);	
 HookConVarChange(sm_timertime, ZombieSmokeSettings);
 //////////////////////////////////////////////
 sm_smokeradius = CreateConVar("sm_smokeradius", "250.0", "Радиус дыма (самый оптимальный стандарт или не ниже 200.0)");
 smokeradius = GetConVarFloat(sm_smokeradius);	
 HookConVarChange(sm_smokeradius, ZombieSmokeSettings);
 //////////////////////////////////////////////
 sm_models = CreateConVar("sm_models", "models\characters\counterterrorist.mdl", "Путь до модели зомби которому доступен дым");
 HookConVarChange(sm_models, ZombieSmokeSettings);
 //////////////////////////////////////////////
 AutoExecConfig(true, "ZombieSmoke");
}

public ZombieSmokeSettings(Handle:Cvar, const String:oldValue[], const String:newValue[])
{
	if (Cvar == sm_timertime)
	{
	timertime = GetConVarFloat(sm_timertime);
	}
	else if (Cvar == sm_smokeradius)
	{
	smokeradius = GetConVarFloat(sm_smokeradius);
	}
	else if (Cvar == sm_models)
	{
	GetConVarString(sm_models, models, sizeof(models));
	}
}

public OnMapStart()
{
  PrecacheSound(SND_SMOKE, true );
  PrecacheModel(models, true);
}

public OnPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
 new client = GetClientOfUserId(GetEventInt(event, "userid"));
 smoke[client] = 1;
 PrintToChat(client, "\x01[\x03%t]\x01%t", "tag", "spawn msg");
}

public Action:drop(client, args)
{

 GetClientModel(client, mdl, sizeof(mdl));
 
 if(IsClientInGame(client) && IsPlayerAlive(client) && smoke[client] > 0 && strcmp(mdl, models, false) == 0)
 {
 PrintToChat(client, "\x01[\x03%t] \x01%t", "tag", "smoke activated");
 EmitSoundToAll(SND_SMOKE);
 OnTimer[client] = CreateTimer(timertime, SmokeOff, client, TIMER_FLAG_NO_MAPCHANGE);
 GetClientAbsOrigin(client, client_pos); 
 smoke[client] = 0;
 CreateEnt(client); 
 }
 else 
 {
 PrintToChat(client, "\x01[\x03%t]\x01%t \x03%.0f", "tag", "no smoke", timertime);
 }
}

public Action:SmokeOff(Handle:timer, any:client) 
{
 smoke[client] = 1;
 PrintToChat(client, "\x01[\x03%t]\x01%t", "tag", "smoke yes");
}

CreateEnt(client) 
{ 
 new ent_smoke = CreateEntityByName("env_smoketrail");
 if(ent_smoke < 1)
 {
 PrintToChat(client, "\x01[\x03Servers-Info.Ru\x01] Сообщите администрации о ошибке №1");
 }
 DispatchKeyValueVector(ent_smoke, "origin", client_pos);
 DispatchKeyValue(ent_smoke, "opacity", "1");
 DispatchKeyValue(ent_smoke, "spawnrate", "15");  
 DispatchKeyValueFloat(ent_smoke, "startsize", smokeradius);  
 
 DispatchSpawn(ent_smoke);
}
